/****************************************************************************
**
** qutIM instant messenger
**
** Copyright (C) 2011 Ruslan Nigmatullin <euroelessar@ya.ru>
**
*****************************************************************************
**
** $QUTIM_BEGIN_LICENSE$
** This program is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation, either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
** See the GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see http://www.gnu.org/licenses/.
** $QUTIM_END_LICENSE$
**
****************************************************************************/

#include "qsoundbackend.h"
#include <QSound>
#include <QDebug>
#include <QStringList>
#include <QFile>

void QSoundBackend::playSound(const QString &filename)
{
	// FIXME: Possibility of freeze at Ubuntu is there
	// May be we should run it at non-gui thread firstly?
	if (!QSound::isAvailable()) {
		qWarning() << "QSound: Unable to play sound";
	}
	QSound(filename).play();
}

QStringList QSoundBackend::supportedFormats()
{
	//TODO
	return QStringList() << "wav";
}
